PRINT " "
PRINT "PARALLEL CASCADE IDENTIFICATION"
PRINT "  (USES UP TO 3RD ORDER CROSSCORRELATION SLICES)"
PRINT "    NORMALIZES LINEAR SYSTEMS IN CASCADES TO HAVE UNITY MEAN-SQ OUTPUT"
PRINT "FITS HYDROPHOBICITY DATA TO -1, 1 OUTPUT; AVOIDING TRANSITION REGION."
PRINT " "
PRINT "DEVISED BY MICHAEL KORENBERG, COPYRIGHT 1987, 1995"
PRINT " "
PRINT "ESTIMATED ZERO ORDER KERNEL WILL BE STORED IN 'K0.DAT'"
PRINT "ESTIMATED FIRST ORDER KERNEL WILL BE STORED IN 'K1.DAT'"
PRINT "ESTIMATED SECOND ORDER KERNEL WILL BE STORED IN 'K2.DAT'"
PRINT " "
PRINT "THE LINEAR SYSTEMS FOUND FOR THE CASCADES WILL BE STORED"
PRINT "IN 'PARALIN.DAT' & THE STATIC NONLINEARITIES IN 'PARAPOLY.DAT'."
PRINT " "
PRINT "(INPUT, RESIDUE) DATA PAIRS WILL BE STORED IN RESIDUE.DAT"
PRINT " "
PRINT "PROGRAM REQUIRES 2-COLUMN INPUT-OUTPUT X(N),Y(N) DATA FILE"
INPUT " NAME OF DATA FILE";A$
DEFINT I-J, M-N, R, T
DEFDBL X,Y,Z,P,A,V,C,H,D
PRINT " "
INPUT "MEMORY LENGTH"; R: RR = R - 1
OPEN A$ FOR INPUT AS #1
I=0:JIR=0
10 INPUT #1, XX, YY: I = I + 1
IF YY > 0 THEN JIR=JIR+1
IF JIR=1 THEN NNEG=I-1
IF I < R THEN GOTO 15
IF JIR < 1 OR JIR > RR THEN YS = YS + YY * YY: AYA = AYA + YY
15 IF EOF(1) THEN GOTO 20
GOTO 10
20 PRINT I; "DATA PAIRS READ"
CLOSE #1
NRR=NNEG+RR-1
INPUT "NUMBER OF DATA PAIRS"; T1
IF T1 > I THEN TI=I
INPUT "MAXIMUM NUMBER OF CASCADE PATHS IN MODEL"; NUM
INPUT "NUMBER OF CANDIDATE CASCADES"; NUM1
IF NUM1 < NUM THEN NUM = NUM1
INPUT "THRESHOLD FOR ACCEPTING CASCADE (FOR 95% CONF INT, TYPE 4; LOWER TO ACCEPT MORE)";A4
INPUT "DEGREE OF (POLYNOMIAL) STATIC NONLINEARITY"; ND: NDD = 2 * ND
INPUT "MAXIMUM % MSE FOR FINAL MODEL"; PMSE
DIM YP(ND), PP(ND, ND), AL(ND, ND - 1), V(ND), CC(NUM, ND)
DIM P(NDD), HJ(RR), H1(RR)
IF ND=1 THEN GOTO 495
DIM H2(RR*(RR+3)\2)
495 P(0) = 1: PP(0, 0) = 1: T1 = T1 - 1
DIM X(T1), Y(T1), Z1(T1)
T11 = T1 - 2*RR + 1
YS = YS / T11: YMSE = YS: AYA = AYA / T11
RANDOMIZE (3): J = 0
OPEN A$ FOR INPUT AS #1
FOR N = 0 TO T1
INPUT #1, X(N), Y(N)
NEXT N
CLOSE #1
OPEN "PARALIN.DAT" FOR OUTPUT AS #3:PRINT #3,A$:PRINT #3,R
25 J = J + 1
30 C = RND
FOR I = 0 TO ND
YP(I) = 0
NEXT I
FOR I = 1 TO ND
FOR II = 0 TO I - 1
AL(I, II) = 0
NEXT II: NEXT I
FOR I = 1 TO ND: FOR II = 0 TO I
PP(I, II) = 0
NEXT II: NEXT I
FOR I = 1 TO NDD: P(I) = 0: NEXT I
IF C > 1 / 3 THEN GOTO 140
'CALCULATE 1ST ORDER CROSSCORRELATION OF INPUT WITH RESIDUE
FOR M1 = 0 TO RR
D = 0: FOR N = RR TO T1
IF N < NNEG OR N > NRR THEN D = D + Y(N) * X(N - M1)
NEXT N
HJ(M1) = D / T11
NEXT M1
GOTO 180
140 CST=YMSE/YS:IF C > 2/3 THEN GOTO 160
'CALCULATE 2ND ORDER CROSSCORRELATION OF INPUT WITH RESIDUE
A = RND: A = FIX(R * A)
FOR M1 = 0 TO RR
D = 0: FOR N = RR TO T1
IF N < NNEG OR N > NRR THEN D=D+Y(N)*X(N-M1)*X(N-A)
NEXT N
HJ(M1) = D / T11
NEXT M1
HJ(A) = HJ(A) + CST
IF C > .5 THEN HJ(A) = HJ(A) - 2 * CST
GOTO 180
160 'CALCULATE 3RD ORDER CROSSCORRELATION OF INPUT WITH RESIDUE
A1 = RND: A1 = FIX(R * A1): A2=RND: A2=FIX(R*A2)
FOR M1 = 0 TO RR
D = 0: FOR N = RR TO T1
IF N < NNEG OR N > NRR THEN D = D + Y(N) * X(N - M1) * X(N - A1)*X(N-A2)
NEXT N
HJ(M1) = D / T11
NEXT M1
HJ(A1) = HJ(A1) + CST
HJ(A2)=HJ(A2)+CST
IF C > .75 AND C <= 5/6 THEN HJ(A1) = HJ(A1) - 2 * CST
IF C > 5/6 AND C <= 11/12 THEN HJ(A2) = HJ(A2)-2*CST
IF C > 11/12 THEN HJ(A1)=HJ(A1)-2*CST:HJ(A2)=HJ(A2)-2*CST
FOR N = 0 TO T1: Z1(N) = 0: NEXT N
FOR M1 = 0 TO RR
FOR N = RR TO T1
Z1(N) = Z1(N) + HJ(M1) * X(N - M1)
NEXT N
NEXT M1
Z1SQ=0
FOR N=RR TO T1
IF N < NNEG OR N > NRR THEN Z1SQ=Z1SQ+Z1(N)*Z1(N)
NEXT N
Z1SQ=SQR(Z1SQ/T11)
FOR M1=0 TO RR:HJ(M1)=HJ(M1)/Z1SQ:NEXT M1
180 FOR N = 0 TO T1: Z1(N) = 0: NEXT N
FOR M1 = 0 TO RR
FOR N = RR TO T1
Z1(N) = Z1(N) + HJ(M1) * X(N - M1)
NEXT N
NEXT M1
'COMPUTE TIME-AVERAGES INVOLVING RESIDUE & CASCADE OUTPUT
200 FOR N = RR TO T1
FOR I = 0 TO ND
IF N < NNEG OR N > NRR THEN YP(I) = YP(I) + Y(N) * Z1(N) ^ I
NEXT I
FOR I = 1 TO NDD
IF N < NNEG OR N > NRR THEN P(I) = P(I) + Z1(N) ^ I
NEXT I
300 NEXT N
FOR I = 0 TO ND: YP(I) = YP(I) / T11: NEXT I
FOR I = 1 TO NDD: P(I) = P(I) / T11: NEXT I
FOR M1 = 1 TO ND
PP(M1, 0) = P(M1)
NEXT M1
FOR M1 = 1 TO ND
FOR R1 = 0 TO M1 - 1
AL(M1, R1) = PP(M1, R1) / PP(R1, R1)
DD = 0: FOR J1 = 0 TO R1
DD = DD + AL(R1 + 1, J1) * PP(M1, J1)
NEXT J1: PP(M1, R1 + 1) = P(M1 + R1 + 1) - DD
NEXT R1
NEXT M1
FOR M1 = 1 TO ND
FOR R1 = 0 TO M1 - 1
YP(M1) = YP(M1) - AL(M1, R1) * YP(R1)
NEXT R1
NEXT M1
FOR M1 = 0 TO ND: YP(M1) = YP(M1) / PP(M1, M1): NEXT M1
CMSE = 0: FOR I = 0 TO ND: CMSE = CMSE + YP(I) * YP(I) * PP(I, I): NEXT I
IF CMSE < A4 * YMSE / T11 THEN IT = IT + 1: IF J + IT - 1 < NUM1 THEN GOTO 30 ELSE GOTO 350
GOTO 360
350 J = J - 1: GOTO 400
360 'CALCULATE COEFS OF STATIC NONLINEARITY
FOR J1 = 0 TO ND: V(J1) = 0: NEXT J1
CC(J, ND) = YP(ND)
FOR M1 = 0 TO ND - 1
V(M1) = 1
FOR J1 = M1 + 1 TO ND
DD = 0: FOR R1 = M1 TO J1 - 1
DD = DD + AL(J1, R1) * V(R1)
NEXT R1
V(J1) = -DD
NEXT J1
DDD = 0: FOR J1 = M1 TO ND
DDD = DDD + YP(J1) * V(J1)
NEXT J1
CC(J, M1) = DDD
NEXT M1
YMSE = ABS(YMSE - CMSE)
JN=J+IT
PRINT "CASCADE #";J;"  %MSE =";100 * YMSE / (YS - AYA * AYA);"  CANDIDATE #";JN
FOR R1 = 0 TO RR
PRINT #3,J,R1,HJ(R1)
H1(R1)=H1(R1)+CC(J,1)*HJ(R1)
IF ND=1 THEN GOTO 500
JR=R1*(R1+1)\2
FOR R2=0 TO R1
JJR=JR+R2
H2(JJR)=H2(JJR)+CC(J,2)*HJ(R1)*HJ(R2)
NEXT R2
500 NEXT R1
IF YMSE < PMSE * YS / 100 THEN GOTO 398
IF J >= NUM THEN GOTO 398
'CALCULATE CASCADE OUTPUT
FOR N = RR TO T1
D = 0: FOR I = 0 TO ND
D = D + CC(J, I) * Z1(N) ^ I
NEXT I
'CALCULATE RESIDUE
Y(N) = Y(N) - D
NEXT N
GOTO 25
398 'CALCULATE CASCADE OUTPUT
FOR N = RR TO T1
D = 0: FOR I = 0 TO ND
D = D + CC(J, I) * Z1(N) ^ I
NEXT I
'CALCULATE RESIDUE
Y(N) = Y(N) - D
NEXT N
400 'CALCULATE KERNELS
OPEN "RESIDUE.DAT" FOR OUTPUT AS #6
FOR N=R TO T1
PRINT #6,X(N),Y(N)
NEXT N
CLOSE #6
OPEN "K0.DAT" FOR OUTPUT AS #1
DE = 0: FOR I = 1 TO J: DE = DE + CC(I, 0): NEXT I
PRINT #1, DE
CLOSE #1
OPEN "K1.DAT" FOR OUTPUT AS #2
FOR R1 = 0 TO RR
PRINT #2, R1, H1(R1)
NEXT R1
CLOSE #2
IF ND=1 THEN GOTO 510
OPEN "K2.DAT" FOR OUTPUT AS #2
FOR R1 = 0 TO RR
FOR R2 = R1 TO RR:JJR=R2*(1+R2)\2+R1
DE=H2(JJR)
PRINT #2, R1, R2, DE
IF R1 < R2 THEN PRINT #2, R2, R1, DE
NEXT R2: NEXT R1:CLOSE #2
510 CLOSE #3
OPEN "PARAPOLY.DAT" FOR OUTPUT AS #1:PRINT #1,A$:PRINT #1,ND
FOR I = 1 TO J
FOR II = 0 TO ND
PRINT #1, I, II, CC(I, II)
NEXT II: NEXT I
CLOSE #1
PRINT "NUMBER OF CASCADE PATHS USED = "; J
PRINT "FINAL % MSE = "; 100 * YMSE / (YS - AYA * AYA)
PRINT A$
BEEP
END

